/* gui_comm.h for run time.  @(#)gui_comm.h	1.1 ARGOS 93/12/13 17:30:33 */

#ifndef GUI_COMM
#define GUI_COMM

/* need these for writing to the debug file */

#include <stdio.h>
#include <time.h>

#include "ui_defs.h"

#ifdef GUI_INIT
#define GUI_EXTERN
#else
#define GUI_EXTERN extern
#endif

#ifdef DEBUG
GUI_EXTERN FILE * DEBUG;
#endif

GUI_EXTERN int GUI_RUN;

GUI_EXTERN long SeqStamp;

/* ALL dot.c files declare these external because
   actuals per gui_tree.h file as written by translator. */

 extern UINODE Nodes[];
 extern NODEID PickActive[];
 extern NODEID Hilited[];
 extern NODEID IsOmitted[];
 extern NODEID HasActed[];
 extern NODEID IsOk[];

/* activation stack of indices into Nodes table. */

GUI_EXTERN NODEID Active_Nodes[UIMaxDepth];

/* dictionary stack kept parallel to activation stack. */

GUI_EXTERN UIDATA* Data[UIMaxDepth];

/* current size (highest valid [level]) of both stacks. */

GUI_EXTERN int Actives;

/* highest valid [level] of dict if higher than activation stack. */

GUI_EXTERN int Dicts;

#define UITOP Active_Nodes[Actives]

#define UIPARENT Active_Nodes[Actives-1]

#define ROOTNODE 1

GUI_EXTERN long GUI_CALLPAR;

/* Strings for buttons */

GUI_EXTERN char APPLY_STR[12];

GUI_EXTERN char EXIT_STR[12];

GUI_EXTERN long By_Gui_Ext;

#undef GUI_EXTERN

/* Run time node info,
   macros make it look like any other node info.
   Two here are other node indices of interest,
   two are flags. */

#define Node_PickActive(n) PickActive[(n)]
#define Node_Hilited(n) Hilited[(n)]
#define Node_Omitted(n) IsOmitted[(n)]
#define Node_Acted(n) HasActed[(n)]
#define Node_IsOk(n) IsOk[(n)]

#endif
