#include <X11/X.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xutil.h>
#include <X11/Xlib.h>
#include <X11/Shell.h>

/* Is junior window a descendant of senior window? */

/* Probably could figure out display from windows -- what is the macro? */

Boolean cx_descent(Display *display, Window senior, Window junior)

{ static char   kws[] = "@(#)cx_descent.c	1.1 ARGOS 94/02/25 11:05:57";

 Window root_window;
 Window parent_window;
 Window *child_windows;
 unsigned int num_children;
 int ii;

/* c y a */

   if (!senior || !junior)
     return False;

/* Senior equals junior or some ancestor of original junior. */

   if (senior == junior)
     return True;

/* Could search downward from senior quitting at last child,
   or up from junior quitting at root or null parent.
   The second method is faster. */

/* Note return Status 0 failure / 1 success.
   Senior is not an ancestor of junior if we reach the top. */

   if (!XQueryTree(display, junior,
                   &root_window,
                   &parent_window,
                   &child_windows,
                   &num_children))
       return False;

   if (!parent_window)
       return False;

/* Senior is parent of junior or some ancestor of original junior. */

   if (senior == parent_window)
     return True;

/* Senior may still be an ancestor of junior. */

   return cx_descent(display, senior, parent_window);
}
