char * mystrtok(char *source, int *offset)

/* Call with the "same" source string every time.
   Set int offset = 0 only before the first call.
   Call repeatedly until null return.

   Note!
   Use a disposable copy of your string.
   This trashes the source string as it works,
   cutting it up by inserting null separators.

   So does the strtok provided by <string.h>
   but this one may be safely used in calls,
   as well as in the caller loop. */

{ static char     kws[] = "@(#)mystrtok.c	1.1 ARGOS 93/12/13 17:37:10";

    int             nonsp;

/* no source or at end of source */

    if (!source || !(*(source + (*offset))))
	return (char *) 0;

/* only on first call,
   scan to the null at the far end,
   then back up to null any trailing spaces. */

    if (!(*offset)) {

/* find the null */

	nonsp = 0;
	while (*(source + nonsp))
	    nonsp++;

/* now pointing at null at zero or later.
   only if later back up one. */

	if (nonsp) {
	    nonsp--;

	    while (nonsp && (*(source + nonsp) == ' ')) {
		*(source + nonsp) = (char) 0;
		nonsp--;
	    }
	}
    }

/* from current offset skip any leading spaces */

    while (*(source + (*offset)) == ' ')
	(*offset)++;

/* at end of source */

    if (!(*(source + (*offset))))
	return (char *) 0;

/* note the first non-space and non-null position */

    nonsp = (*offset);

/* advance offset while not null or space or tab or slash,
   so the next call will start beyond this word. */

    while (*(source + (*offset))
	&& (*(source + (*offset)) != ' ')
	&& (*(source + (*offset)) != '\t')
	&& (*(source + (*offset)) != '/'))
	(*offset)++;

/* no valid last word - ran out of trailing blanks */

    if (nonsp == (*offset))
	return (char *) 0;

/* only if not already so,
   null-terminate the part we will report */

    if (*(source + (*offset))) {
	*(source + (*offset)) = (char) 0;
	(*offset)++;
    }

/* report a word w/no leading or trailing spaces */

    return &(source[nonsp]);
}
