/* NEW STUFF TO BE ADDED JUST COMMENT FOR NOW
   See longer comments in uidef.

   Not sure if the test should prevent an undef,
   but useful to let the routine know at least.

   Check the "Active" attribute of an existing data entry,
   if non-zero it is a function to call as follows,
   int ok = Data_Active(xx) (xx, proper_typed_value)
   only do the undef if ok returned as non-zero. */

#include <string.h>
#include "gui_comm.h"

void uiundef(char *ename)

/* Undefine an entry by name in every dictionary.
   Entry is a descriptor with name and value or pointer. */

{ static char     kws[] = "@(#)uiundef.c	1.1 ARGOS 93/12/13 17:37:19";

    int            *DIE = 0;

    UIDATA         *ii;
    UIDATA         *prev;

    int             level;

/* c y a */

    if (!ename || !strlen(ename))
      return;

    for (level = Actives; level > 0; level--) {
	prev = 0;
	for (ii = Data[level];
	     ii;
	     prev = ii, ii = Data_Sibling(ii)) {
	    if (strcasecmp(ename,
		Data_Name(ii)) == 0) {

		if (prev)
		    Data_Sibling(prev) = Data_Sibling(ii);

		else
		    Data[level] = Data_Sibling(ii);

		switch (Data_Kind(ii)) {

		case LONGVAL:
#ifdef DEBUG
		    if (DEBUG)
			fprintf(DEBUG,
				"undef LONG ss %ld %s,%s as %d\n",
				Data_SeqStamp(ii), Node_Name(UITOP),
		Data_Name(ii), Data_LValue(ii));
#endif
		    break;

		case FLOATVAL:
#ifdef DEBUG
		    if (DEBUG)
			fprintf(DEBUG,
				"undef FLOAT ss %ld %s,%s as %f\n",
				Data_SeqStamp(ii), Node_Name(UITOP),
		Data_Name(ii), Data_FValue(ii));
#endif
		    break;

		case DOUBLEVAL:
#ifdef DEBUG
		    if (DEBUG)
			fprintf(DEBUG,
				"undef DOUBLE ss %ld %s,%s as %lf\n",
				Data_SeqStamp(ii), Node_Name(UITOP),
		Data_Name(ii), Data_DValue(ii));
#endif
		    break;

		case STRINGVAL:
#ifdef DEBUG
		    if (DEBUG)
			fprintf(DEBUG,
				"undef STRING ss %ld %s,%s as %s\n",
				Data_SeqStamp(ii), Node_Name(UITOP),
		Data_Name(ii), Data_SValue(ii));
#endif
		    free(Data_SValue(ii));
		    break;

		case STRUCTVAL:

		case MALLOCVAL:
#ifdef DEBUG
		    if (DEBUG)
			fprintf(DEBUG,
				"undef MALLOC/STRUCT ss %ld %s,%s as %ld\n",
				Data_SeqStamp(ii), Node_Name(UITOP),
		Data_Name(ii), Data_SValue(ii));
#endif
		    free(Data_SValue(ii));
		    break;
		}
		free(ii);
		break;
	    }
	}
    }

#ifdef DEBUG
    if (DEBUG)
	fflush(DEBUG);
#endif
}
