/* uiyacc.y */

%{
   
#include <stdio.h>

int want_token;

extern int yylineno;

#define UITOC_EXTERN

#include "uitoc_comm.h"

#include "uitoc_heads.h"

#define UITOP Active_Nodes[Actives]
#define UIPARENT Active_Nodes[Actives-1]

#include <stdio.h>
#include <string.h>

/* this is used to print "fun2" for 2 etc but plain "0" for 0 */

#define fund(num) ((num) > 0) ? "fun" : ""
#define extend(a) fund(a), a

/* used to print "name" for name etc but plain "0" */

#define orzero(a) ((a) ? a : "0")

/* to print "sizeof(name)" or "0" if none */

#define xll(str) ((int)(str) > 0) ? "sizeof(" : ""
#define xrr(str) ((int)(str) > 0) ? ")" : ""
#define asize(a) xll(a), orzero(a), xrr(a)

#define setopt(opt,num) (opt = num)

FILE *fcode;
FILE *ftree;

int cases;

static char   kws[] = "@(#)uiyacc.y	1.1 ARGOS 93/12/13 17:45:28";

int ii;

%}

%union  {
	float rval;
	double dval;

	int ival;
	long lval;

	char *text;
	}

%token  INCLUDE EVERY_TIME

%token  AND OR POPUP TOOLBAR SWITCH EMPTY

%token  AT DOES

%token  ALL NONE

%token  ALLOW DISALLOW DISCARD

%token  IMMEDIATE TERMINAL READ_ONLY

%token  BOOLEAN CHOICES CHOOSE_ONE PICK SELECT RFILE

%token  DEFAULT AUTO_SELECT

%token  HIGHLIGHT STRUCTURED PERMANENT

%token  STRING NO_ECHO TO_LOWER TO_UPPER

%token  MIN MAX SET INITVAL

%token	FILL_COLOR BODY_COLOR ON_COLOR LABEL_COLOR

%token  LAYOUT LEFT RIGHT WIDTH WINDOW TAB VADJUST VTAB

%token  LABEL SIZE

%token  DECODE ENCODE INT FLOAT DOUBLE

%token  ENABLE_CHOICE SUMMARY EVENT_TEST OMIT FOLLOWS

%token  AUTO_OK ENABLE_OK ACTION ACTION_MSG ON_EXIT CLICK_ACTION

%token  ON_ENTRY HELP REMAIN CONFIRM CONFIRM_MSG CYCLE

%token  MOUSE_PICK NO_LABEL ON_CR OVERLAYS PLACE

%token	SAME COPY

%token  _END

%type   <ival> Num_type

%token  <ival> LETTER

%token  <ival> INTEGER

%token  <ival> SUBTREE

%token  <text> TEXT

%token  <text> NEW_NAME

%token  <text> SIBLING

%token  <text> BLOCK

%type   <text> Block

%type   <text> Lay_Name

%start  S

%%

/* Open a file for all the attribute code blocks. */

S   :	{ if (!(fcode = fopen("node_code.c", "w"))) {
	      fprintf(stderr, "can not create node_code.c");
	      exit (-1);
	  }

	  if (!(ftree = fopen("gui_tree.h", "w"))) {
	      fprintf(stderr, "can not create gui_tree.h");
	      exit (-1);
	  }

	  fprintf(ftree, "\n/* Made by uitoc %s */\n", kws);
	  fprintf(ftree, "\n/* Do not edit this file! */\n");
	  fprintf(ftree, "\n/* %s */\n", timestamp());

	  fprintf(ftree, "\n#include \"ui_defs.h\"\n");
	  fprintf(ftree, "\n#include \"node_heads.h\"\n");
	  fprintf(ftree, "\n#include \"thumb_heads.h\"\n");

/* Tell any reader what this file is. */

	  fprintf(fcode, "\n/* Made by uitoc %s */\n", kws);
	  fprintf(fcode, "\n/* Do not edit this file! */\n");
	  fprintf(fcode, "\n/* Edit the .ui file instead. */\n");
	  fprintf(fcode, "\n/* %s */\n", timestamp());

/* Provide includes that gui always needs. */

	  fprintf(fcode, "\n#include <stdio.h>");
	  fprintf(fcode, "\n#include <stdlib.h>");
	  fprintf(fcode, "\n#include \"gui_comm.h\"");
	  fprintf(fcode, "\n#include \"gui_tree.h\"");

/* Declare externals that gui routines will provide.
   These are available in ACTION code of terminals. */

	  gui_exts(fcode); }

/* Start with any application-specific globals and includes.
   We have automatically provided the 'std' and 'gui' includes. */

		Includes

/* Start the collection of attributes code blocks.

   Lots of things use "1" so we provide it and use for all.

   Each block is written as a Numbered function,
   while also building a connection tree,
   that will be printed when it is complete. */

		{ fprintf(fcode,
			  "\nlong fun1 (NODEID nodeid) { return 1; }\n");

		  cases = 5; }

/* The root node must be an Or node. */

		Root_Node

/* The root has now been defined by all other Nodes.
   All code blocks have been seen and assigned function Numbers.
   Close the code block file and print the attribute tree.

   There is a limit to the number of args to one print statement,
   and we have exceeded it! */

		{ fclose(fcode);

		  fprintf(ftree, "\n#define GUINodes %d", Allocated+1);
		  fprintf(ftree, "\n UINODE Nodes[GUINodes] = {\n");

		  for (ii = 0; ii <= Allocated; ii++) {

		    fprintf(ftree,
"\n/* node %d */\n\
{ \"%s\",\n\
 \"%s\",\n\
 \"%s\",\n\
 %d, %d, %d,\n\
 %d, %d, %d, %d,\n\
 %d,\n\
 %d, %d,\n\
 %d,\n\
 %s%d, %s%d,\n\
 %s%d, %s%d, %s%d, %s%d,\n\
 %s%d, %s%d,\n\
 %s%d, %s%d, %s%d, %s%d,\n\
 %s%s%s,\n",
			ii,

			Node_Name(ii),
			(Node_Help(ii) ? Node_Help(ii) : ""),
			(Node_On_Cr(ii) ? Node_On_Cr(ii) : ""),

			Node_Level(ii),
			Node_Kind(ii),
			Node_Term_Kind(ii),

			Node_Child(ii),
			Node_Sibling(ii),
			Node_Back(ii),
			Node_Popup(ii),

			Node_Layout_Style(ii),

			Node_Struct_Ptr(ii),
			Node_Flags(ii),

			Node_Spare(ii),

			extend(Node_Follows(ii)),
			extend(Node_Overlays(ii)),

			extend(Node_Layout_Left(ii)),
			extend(Node_Layout_Right(ii)),
			extend(Node_Layout_Tab(ii)),
			extend(Node_Layout_VTab(ii)),

			extend(Node_Place_X(ii)),
			extend(Node_Place_Y(ii)),

			extend(Node_Window_X(ii)),
			extend(Node_Window_Y(ii)),
			extend(Node_Window_W(ii)),
			extend(Node_Window_H(ii)),

			asize(Node_StrucSize(ii)));

		    fprintf(ftree,
" %s%d, %s%d,\n\
 %s%d, %s%d, %s%d, %s%d,\n\
 %s%d, %s%d,\n\
 %s%d, %s%d, %s%d, %s%d,\n\
 %s%d,\n\
 %s%d, %s%d, %s%d, %s%d,\n\
 %s%d, %s%d, %s%d, %s%d,\n\
 %s%d, %s%d, %s%d,\n\
 %s%d,\n\
 %s%d, %s%d,\n\
 %s%d,\n",
			extend(Node_Enable_Choice(ii)),
			extend(Node_Omit(ii)),

			extend(Node_Click_Action(ii)),
			extend(Node_Auto_Ok(ii)),
			extend(Node_Read_Only(ii)),
			extend(Node_Enable_Ok(ii)),

			extend(Node_Remain(ii)),
			extend(Node_Confirm(ii)),

			extend(Node_Conf_Msg(ii)),
			extend(Node_Discard(ii)),
			extend(Node_Event_Test(ii)),
			extend(Node_No_Label(ii)),

			extend(Node_Fill_Color(ii)),

			extend(Node_Body_Color(ii)),
			extend(Node_On_Color(ii)),
			extend(Node_Label_Color(ii)),
			extend(Node_Mouse_Color(ii)),

			extend(Node_Summary(ii)),
			extend(Node_Def_Pick(ii)),
			extend(Node_Auto_Select(ii)),
			extend(Node_Highlight(ii)),

			extend(Node_On_Entry(ii)),
			extend(Node_On_Exit(ii)),
			extend(Node_Action(ii)),

			extend(Node_For_List(ii)),

			extend(Node_Pick(ii)),
			extend(Node_No_Pick(ii)),

			extend(Node_RFile(ii)));

		    fprintf(ftree,
" %s%d, %s%d, %s%d, %s%d, %s%d, %s%d,\n\
 %d,\n\
 %s%d,\n\
 %s, %s,\n\
 %s%d,\n\
 %s%d, %s%d, %s%d,\n\
 %s%d, %s%d, %s%d,\n\
 %s%d, %s%d, %s%d\n\
 %s",
			extend(Node_Choice_Set(ii)),
			extend(Node_Choice_Init(ii)),
			extend(Node_Choice_Allow(ii)),
			extend(Node_Choice_DisAllow(ii)),
			extend(Node_Choice_Min(ii)),
			extend(Node_Choice_Max(ii)),

			Node_Choice_Key_Case(ii),

			extend(Node_Str_No_Echo(ii)),

			orzero(Node_Term_Encode(ii)),
			orzero(Node_Term_Decode(ii)),

			extend(Node_Term_Width(ii)),

			extend(Node_Long_Init(ii)),
			extend(Node_Long_Min(ii)),
			extend(Node_Long_Max(ii)),

			extend(Node_Float_Init(ii)),
			extend(Node_Float_Min(ii)),
			extend(Node_Float_Max(ii)),

			extend(Node_Double_Init(ii)),
			extend(Node_Double_Min(ii)),
			extend(Node_Double_Max(ii)),

			(ii < Allocated) ? "} ,\n" : "} };");
		  }

		  fprintf(ftree, "\n/* These are externs of unknown size in gui_comm.h,");
		  fprintf(ftree, "\n   sized and declared here to be found by it. */");
		  fprintf(ftree, "\n");

		  fprintf(ftree, "\nNODEID PickActive[GUINodes];");
		  fprintf(ftree, "\nNODEID Hilited[GUINodes];");
		  fprintf(ftree, "\nint IsOmitted[GUINodes];");
		  fprintf(ftree, "\nint HasActed[GUINodes];");
		  fprintf(ftree, "\nint IsOk[GUINodes];");

		  fprintf(ftree, "\n");
		  fclose(ftree);
		  printf("\n%s\n", kws);

		  return (0); }
	;

Includes :	/* nothing */
	|	INCLUDE Block
		{ fprintf(fcode, "\n/* Includes */\n%s\n", $2); }
	;

/* Build a tree of Nodes.
   Set any node attributes as provided.
   Set default attributes where required and none given.

   Write any node method code to the output file,
   providing a sequential case Number for each block,
   and using these Numbers as node attributes. */

Root_Node :	OR { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(OrNode, $3);
		  fprintf(fcode,
		          "\n/* Root %d %s */\n",
		          UITOP, Node_Name(UITOP)); }
		Or_Opts Top_Nodes _END TEXT
		{ uiendnode($8); }
	;

Top_Nodes :	Top_Node
	|	Top_Nodes Top_Node
	;

Top_Node :	In_Node
	|	Toolbar_Menu
	;

In_Node :	And_Node
	|	Or_Node
	|	Popup_Menu
	|	Switch_Node
	;

/* Note that any options must come before subNodes!
   (Otherwise they would apply to the subnode.)
   Options may be written in any order.
   Caution!
   There is a problem with this style of option lists;
   no options at all is syntactically correct,
   but a few are usually required!
   We should check in the C-code before doing a uiendnode call,
   either provide defaults if we can,
   or diagnostics. */

And_Node :      AND { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(AndNode, $3);
		  fprintf(fcode,
		          "\n/* And %d %s */\n",
		          UITOP, Node_Name(UITOP)); }
		 And_Opts Nodes_Empty _END TEXT
		{ uiendnode($8); }
	;

And_Opts :      /* nothing */
	|	And_Opts And_Opt
	;

And_Opt :	All_Opt
	|	Fill_Color
	|	Summary
	|	Mouse_Pick
	|	Highlight
	|	Auto_Ok
	|	Enable_Ok
	|	Confirm
	|	Conf_Msg
	|	Event_Test
	|	Action
	|	Remain
	;

/* Allow an explicit empty and-node.
   This shows the built-in HELP CANCEL APPLY buttons.
   It is useful as a Confirm box. */

Nodes_Empty :	Nodes
	|	EMPTY
	;

Or_Node :	OR { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(OrNode, $3);
		  fprintf(fcode,
		          "\n/* Or %d %s */\n",
		          UITOP, Node_Name(UITOP)); }
		Or_Opts Nodes _END TEXT
		{ uiendnode($8); }
	;

/* A special kind of OrNode w/out any user-provided name,
   because none needed:  Only one of these per internal node.
   Popup Menu items are restricted to LABEL and IMMEDIATE actions,
   which will have access to mouse coordinates,
   and should be here only for this reason. */

Popup_Menu :	POPUP
		{ want_token = TEXT;
  		  uinewnode(OrNode, "popup_menu");
		  fprintf(fcode,
		          "\n/* Popup %d for %s */\n",
		          UITOP, Node_Name(Node_Back(UITOP))); }
		Popup_Opts Popup_Nodes _END POPUP
		{ uiendnode("popup_menu"); }
	;

Popup_Opts :	/* nothing */
	|	Popup_Opts Popup_Opt
	;

Popup_Opt :	All_Opt
	|	Summary
	;

Popup_Nodes :	Popup_Node | Popup_Nodes Popup_Node ;

Popup_Node :	Immediate
	|	Label
	;

/* Another special AndNode w/out any name.
   Menu items are restricted to LABEL, IMMEDIATE, BOOLEAN, CYCLE.
   Only one of these and only at top level. */

Toolbar_Menu :	TOOLBAR
		{ want_token = TEXT;
  		  uinewnode(AndNode, "toolbar");
		  fprintf(fcode,
		          "\n/* Toolbar %d */\n",
		          UITOP); }
		Toolbar_Opts Toolbar_Nodes _END TOOLBAR
		{ uiendnode("toolbar"); }
	;

Toolbar_Opts :	/* nothing */
	|	Toolbar_Opts Toolbar_Opt
	;

Toolbar_Opt :	All_Opt
	|	Summary
	;

Toolbar_Nodes :	Toolbar_Node | Toolbar_Nodes Toolbar_Node ;

Toolbar_Node :	Immediate
	|	Label
	|	Boolean
	|	Cycle
	|	Choose_One
	;

Or_Opts :	/* nothing */
	|	Or_Opts Or_Opt
	;

Or_Opt :	All_Opt
	|	Fill_Color
	|	Summary
	|	Mouse_Pick
	|	Auto_Select
	|	Highlight
	|	Remain
	|	Event_Test
	;

Switch_Node :	SWITCH { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(SwitchNode, $3); }
		Sw_Opts Nodes _END TEXT
		{ uiendnode($8); }
	;

Sw_Opts :	/* nothing */
	|	Sw_Opts Sw_Opt
	;

Sw_Opt :	On_Entry
	|	On_Exit
	|	Enable_Choice
	|	Summary
	|	Confirm
	|	No_Label
	|	Width
	|	Conf_Msg
	;

/* Note that either And_Node or Or_Node allow terminals!
   Single terminals can be complete commands. */

Nodes :		Node | Nodes Node ;

Node :		In_Node
	|	Label
	|	Layout
	|	Immediate
	|	Boolean
	|	Number
	|	String
	|	Choices
	|	Choose_One
	|	Cycle
	|	Structured
	|	Select
	|	SubTree
	|	Copy
	;

Label :		LABEL { want_token = NEW_NAME; } NEW_NAME Block
		{ want_token = TEXT;
  		  uinewnode(LabelNode, $3);

		  fprintf(fcode,
		          "\n/* Label %d %s */\nchar * fun%d (NODEID nodeid) {%s}\n",
		          UITOP, Node_Name(UITOP), ++cases, $4);
		  setopt(Node_Summary(UITOP), cases); }
		 Label_Opts _END TEXT
		{ uiendnode($8); }
	;

Label_Opts :	/* nothing */
	|	Label_Opts Label_Opt
	;

Label_Opt :	Omit
	|	Enable_Choice
	|	No_Label
	|	Overlays
	|	Follows
	|	VAdjust
	|	Width
	|	Label_Color
	;

Layout :	 LAYOUT Lay_Name
		{ uinewnode(LayoutNode, $2); }
		 Lay_Opts
		{ uiendnode($2); }
	;

Lay_Name :	/* nothing becomes empty string not null */
		{ $$ = ""; }
	|	TEXT
		{ $$ = $1; }
	;

Lay_Opts :	/* nothing */
	|	Lay_Opts Lay_Opt
	;

Lay_Opt :	LEFT Block
		{ fprintf(fcode,
			  "\n/* left */\nlong fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  setopt(Node_Layout_Left(UITOP), cases); }
	|       RIGHT Block
		{ fprintf(fcode,
			  "\n/* right */\nlong fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  setopt(Node_Layout_Right(UITOP), cases); }
	|       TAB Lay_Tab_Rest
	|       VTAB Lay_VTab_Rest
	;

/* The RIGHT way to do this is a general-purpose Int_Value,
   that accepts a direct value or block of code or nil,
   with each caller filling in the specifics.
   And likewise for Float and String and whatever. */

Lay_Tab_Rest:	INTEGER
		{ if ($1 == 1)
			Node_Layout_Tab(UITOP) = 1;
		  else if ($1) {
		 	fprintf(fcode,
			  "\n/* Layout_Tab_Nr %s */\nlong fun%d (NODEID nodeid) { return %d; }\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Layout_Tab(UITOP), cases); } }
	|	Block
		{ fprintf(fcode,
			  "\n/* Layout_Tab_Fun %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Layout_Tab(UITOP), cases); }
	;

Lay_VTab_Rest:	INTEGER
		{ if ($1 == 1)
			Node_Layout_VTab(UITOP) = 1;
		  else if ($1) {
		 	fprintf(fcode,
			  "\n/* Layout_VTab_Nr %s */\nlong fun%d (NODEID nodeid) { return %d; }\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Layout_VTab(UITOP), cases); } }
	|	Block
		{ fprintf(fcode,
			  "\n/* Layout_VTab_Fun %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Layout_VTab(UITOP), cases); }
	;

VAdjust :	VADJUST Block
		{ fprintf(fcode,
			  "\n/* VADJ */\nlong fun%d (NODEID nodeid) {%s}\n",
		  ++cases, $2);
		  setopt(Node_Place_Y(UITOP), cases); }
	;

/* Immediate Action when pressed. */

Immediate :	IMMEDIATE { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(ImmNode, $3); }
		 Imm_Opts _END TEXT
		{ uiendnode($7); }
	;

Imm_Opts :	/* nothing */
	|	Imm_Opts Imm_Opt
	;

Imm_Opt :	All_Opt
	|	Auto_Ok
	|	Summary
	|	Action
	|	Click_Act
	|	Remain
	|	Confirm
	|	Conf_Msg
	;

Boolean :	BOOLEAN { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(TermNode, $3);
		  Node_Term_Kind(UITOP) = BOOLEAN_TERM; }
		 Bool_Opts _END TEXT
		{ uiendnode($7); }
	;

Bool_Opts :	/* nothing */
	|	Bool_Opts Bool_Opt
	;

Bool_Opt :	All_Opt
	|	Auto_Ok
	|	Action
	|	Remain
	|	Term_Init
	|	Read_Only
	|	Confirm
	|	Conf_Msg
	;

/* Numeric value as int / float / double type.
   Provide default text representation if none given. */

Number :	Num_type { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(TermNode, $3);
		  Node_Term_Kind(UITOP) = $1; }
		Num_Opts _END TEXT
		{ switch (Node_Term_Kind(UITOP)) {
		  case INT_TERM:
		  if (!(Node_Term_Encode(UITOP)))
			Node_Term_Encode(UITOP) = "l_dec";
		  if (!(Node_Term_Decode(UITOP)))
			Node_Term_Decode(UITOP) = "dec_l";
		      break;
		  case FLOAT_TERM:
		  if (!(Node_Term_Encode(UITOP)))
			Node_Term_Encode(UITOP) = "f_dec";
		  if (!(Node_Term_Decode(UITOP)))
			Node_Term_Decode(UITOP) = "dec_f";
		      break;
		  case DOUBLE_TERM:
		  if (!(Node_Term_Encode(UITOP)))
			Node_Term_Encode(UITOP) = "d_dec";
		  if (!(Node_Term_Decode(UITOP)))
			Node_Term_Decode(UITOP) = "dec_d";
		      break;
		  }
		  uiendnode($7); }
	;

Num_type :	INT
		{ $$ = INT_TERM; }
	|       FLOAT
		{ $$ = FLOAT_TERM; }
	|       DOUBLE
		{ $$ = DOUBLE_TERM; }
	;

Num_Opts :	/* nothing */
	|	Num_Opts Num_Opt
	;

Num_Opt :	All_Opt
	|       Action
	|       Term_Min
	|       Term_Max
	|       Term_Init
	|	Read_Only
	|       Term_Encode
	|       Term_Decode
	;

String :	STRING { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(TermNode, $3);
		  Node_Term_Kind(UITOP) = STRING_TERM; }
		Str_Opts _END TEXT
		{ uiendnode($7); }
	;

Str_Opts :	/* nothing */
	|	Str_Opts Str_Opt
	;

Str_Opt :	All_Opt
	|	Auto_Ok
	|       Action
	|       Term_Init
	|	Read_Only
	|       Term_Max
	|       Term_Decode
	|       Key_case
	|       Str_NEcho
	;

Select :	SELECT { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(TermNode, $3);
		  Node_Term_Kind(UITOP) = SELECT_TERM; }
		Sel_Opts _END TEXT
		{ uiendnode($7); }
	;

Sel_Opts :	/* nothing */
	|	Sel_Opts Sel_Opt
	;

Sel_Opt :	All_Opt
	|	Auto_Ok
	|       Action
	|	Summary
	|	Enable_Ok
	|	Remain
	|	Term_Init
	|	Choice_Set
	|	Click_Act
	|	rfile
	;

SubTree :	SAME { want_token = SUBTREE; } SUBTREE
		{ uidupnode($3); want_token = TEXT; }
	;

Copy :		COPY
		{ want_token = SUBTREE; } SUBTREE
		{ want_token = NEW_NAME; } NEW_NAME
		{ uicopynode($3, $5);
		  want_token = TEXT; }
		Copy_Opts _END TEXT
		{ uiendnode($9); }
	;

Copy_Opts :	/* nothing */
	|	Copy_Opts Copy_Opt
	;

Copy_Opt :	All_Opt
	|	Fill_Color
	;

rfile :		RFILE Block
		{ fprintf(fcode,
			  "\n/* rfile */\nFILE * fun%d (NODEID nodeid) {%s}\n",
		  ++cases, $2);
		  Node_RFile(UITOP) = cases; }
	;

Cycle :		CYCLE { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(TermNode, $3);
		  Node_Term_Kind(UITOP) = CYCLE_TERM; }
		Cyc_Opts _END TEXT
		{ if (!(Node_Term_Encode(UITOP)))
			Node_Term_Encode(UITOP) = "wordx";
		  if (!(Node_Term_Decode(UITOP)))
			Node_Term_Decode(UITOP) = "cycle_l";
		  uiendnode($7); }
	;

Cyc_Opts :	/* nothing */
	|	Cyc_Opts Cyc_Opt
	;

Cyc_Opt :	All_Opt
	|       Action
	|       Term_Init
	|	Read_Only
	|       Choice_Set
	;

Structured :	STRUCTURED TEXT { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(TermNode, $4);
		  Node_StrucSize(UITOP) = $2;
		  Node_Term_Kind(UITOP) = STRUCT_TERM; }
		Struc_Opts _END TEXT
		{ if (!(Node_Term_Encode(UITOP))
			|| !(Node_Term_Decode(UITOP))) {
		      printf("required encode/decode for %s\n",
			 Node_Name(UITOP));
			 exit (-1);
		  }
		  uiendnode($8); }
	;

Struc_Opts :	/* nothing */
	|	Struc_Opts Struc_Opt
	;

Struc_Opt :	All_Opt
	|	Action
	|	Click_Act
	|	Term_Init
	|	Read_Only
	|	Term_Encode
	|	Term_Decode
	|	Choice_Set
	;

Choices :	CHOICES { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(TermNode, $3);
		  Node_Term_Kind(UITOP) = CHOICE_TERM; }
		Ch_Opts
		_END TEXT
		{ uiendnode($7); }
	;

Ch_Opts :	/* nothing */
	|	Ch_Opts Ch_Opt
	;

Ch_Opt :	All_Opt
	|	Auto_Ok
	|	Fill_Color
	|	Summary
	|	Enable_Ok
	|	Action
	|	Remain
	|	Choice_Set
	|	Choice_Allow
	|	Choice_Disallow
	|	Term_Init
	|	Read_Only
	|	Ch_Min
	|	Ch_Max
	|	Key_case
	|	Click_Act
	|	LAYOUT Lay_Opts
	;

Choose_One :	CHOOSE_ONE { want_token = NEW_NAME; } NEW_NAME
		{ want_token = TEXT;
  		  uinewnode(TermNode, $3);
		  Node_Term_Kind(UITOP) = CHOICE_TERM;
		  Node_Choice_Min(UITOP) = 1;
		  Node_Choice_Max(UITOP) = 1; }
		Ch_One_Opts
		_END TEXT
		{ uiendnode($7); }
	;

Ch_One_Opts :	/* nothing */
	|	Ch_One_Opts Ch_One_Opt
	;

Ch_One_Opt :	All_Opt
	|	Auto_Ok
	|	Enable_Ok
	|	Action
	|	Choice_Set
	|	Choice_Allow
	|	Choice_Disallow
	|	Term_Init
	|	Click_Act
	;

Click_Act:	CLICK_ACTION Block
		{ fprintf(fcode,
			  "\n/* Click_Act %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $2);
		  setopt(Node_Click_Action(UITOP), cases); }
	;

Key_case :	TO_UPPER
		{ Node_Choice_Key_Case(UITOP) = UP_CODE; }
	|       TO_LOWER
		{ Node_Choice_Key_Case(UITOP) = DOWN_CODE; }
	;

Choice_Set :	SET Block
		{ fprintf(fcode,
			  "\n/* Choice_Set */\nchar * fun%d (NODEID nodeid) {%s}\n",
		  ++cases, $2);
		  Node_Choice_Set(UITOP) = cases; }
	;

Choice_Allow :	ALLOW Block
		{ fprintf(fcode,
			  "\n/* Choice_Allow */\nchar * fun%d (NODEID nodeid) {%s}\n",
		  ++cases, $2);
		  Node_Choice_Allow(UITOP) = cases; }
	;

Choice_Disallow : DISALLOW Block
		{ fprintf(fcode,
			  "\n/* Choice_Disallow */\nchar * fun%d (NODEID nodeid) {%s}\n",
		  ++cases, $2);
		  Node_Choice_DisAllow(UITOP) = cases; }
	;

Ch_Min :	MIN Ch_Min_Rest ;

Ch_Min_Rest:	INTEGER
		{ if ($1 == 1)
			Node_Choice_Min(UITOP) = 1;
		  else if ($1) {
		 	fprintf(fcode,
			  "\n/* Choice_Min_Nr %d %s */\nlong fun%d (NODEID nodeid) { return %d; }\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Choice_Min(UITOP), cases); } }
	|	Block
		{ fprintf(fcode,
			  "\n/* Choice_Min_Fun %d %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Choice_Min(UITOP), cases); }
	;

Ch_Max :	MAX Ch_Max_Rest ;

Ch_Max_Rest:	INTEGER
		{ if ($1 == 1)
			Node_Choice_Max(UITOP) = 1;
		  else if ($1) {
			fprintf(fcode,
			  "\n/* Choice_Max_Nr %d %s */\nlong fun%d (NODEID nodeid) { return %d; }\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Choice_Max(UITOP), cases); } }
	|	Block
		{ fprintf(fcode,
			  "\n/* Choice_Max_Fun %d %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Choice_Max(UITOP), cases); }
	;

/* Notice!
   For now at least,
   a structured item uses a string to initialize,
   as it will be shown by the thumbwheel.
   We can do otherwise if some reason appears. */

Term_Init :	INITVAL Init_Rest ;

Init_Rest :	Init_Block
	|	ALL
		{ fprintf(fcode,
			  "\n/* Term_Init */\nchar * fun%d (NODEID nodeid) { return \"ALL\"; }\n",
			  ++cases);
		  Node_Choice_Init(UITOP) = cases; }
	|	NONE
		{ fprintf(fcode,
			  "\n/* Term_Init */\nchar * fun%d (NODEID nodeid) { return \"NONE\"; }\n",
			  ++cases);
		  Node_Choice_Init(UITOP) = cases; }
	;

Init_Block :	Block
		{ switch (Node_Term_Kind(UITOP)) {
		  case CHOICE_TERM:
		  case STRING_TERM:
		  case STRUCT_TERM:
		  case SELECT_TERM:
		  fprintf(fcode,
			  "\n/* Term_Init */\nchar * fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $1);
		  Node_Choice_Init(UITOP) = cases;
		  break;
		  case INT_TERM:
		  case BOOLEAN_TERM:
		  case CYCLE_TERM:
		  fprintf(fcode,
			  "\n/* Term_Init */\nlong fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $1);
		  Node_Long_Init(UITOP) = cases;
		  break;
		  case FLOAT_TERM:
		  fprintf(fcode,
			  "\n/* Term_Init */\nfloat fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $1);
		  Node_Float_Init(UITOP) = cases;
		  break;
		  case DOUBLE_TERM:
		  fprintf(fcode,
			  "\n/* Term_Init */\ndouble fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $1);
		  Node_Double_Init(UITOP) = cases;
		  break;
		  default:
		  printf("unexpected init case %d for %s\n",
			 Node_Term_Kind(UITOP),
			 Node_Name(UITOP));
			 exit (-1);
		  } }
	;

Term_Min :	MIN Block
		{ switch (Node_Term_Kind(UITOP)) {
		  case CHOICE_TERM:
		  case STRING_TERM:
		  fprintf(fcode,
			  "\n/* Term_Min */\nlong fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  Node_Choice_Min(UITOP) = cases;
		  break;
		  case INT_TERM:
		  fprintf(fcode,
			  "\n/* Long_Min */\nlong fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  Node_Long_Min(UITOP) = cases;
		  break;
		  case FLOAT_TERM:
		  fprintf(fcode,
			  "\n/* Float_Min */\nfloat fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  Node_Float_Min(UITOP) = cases;
		  break;
		  case DOUBLE_TERM:
		  fprintf(fcode,
			  "\n/* Double_Min */\ndouble fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  Node_Double_Min(UITOP) = cases;
		  break;
		  default:
		  printf("unexpected min case %d for %s\n",
			 Node_Term_Kind(UITOP),
			 Node_Name(UITOP));
			 exit (-1);
		  } }
	;

Term_Max :	MAX Block
		{ switch (Node_Term_Kind(UITOP)) {
		  case CHOICE_TERM:
		  case STRING_TERM:
		  fprintf(fcode,
			  "\n/* Term_Max */\nlong fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  Node_Choice_Max(UITOP) = cases;
		  break;
		  case INT_TERM:
		  fprintf(fcode,
			  "\n/* Long_Max */\nlong fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  Node_Long_Max(UITOP) = cases;
		  break;
		  case FLOAT_TERM:
		  fprintf(fcode,
			  "\n/* Float_Max */\nfloat fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  Node_Float_Max(UITOP) = cases;
		  break;
		  case DOUBLE_TERM:
		  fprintf(fcode,
			  "\n/* Double_Max */\ndouble fun%d (NODEID nodeid) {%s}\n",
			  ++cases, $2);
		  Node_Double_Max(UITOP) = cases;
		  break;
		  default:
		  printf("unexpected max case %d for %s\n",
			 Node_Term_Kind(UITOP),
			 Node_Name(UITOP));
			 exit (-1);
		  } }
	;


Term_Encode :	ENCODE TEXT
		{ Node_Term_Encode(UITOP) = $2; }
	;

Term_Decode :	DECODE TEXT
		{ Node_Term_Decode(UITOP) = $2; }
	;

All_Opt :	On_Entry
	|	On_Exit
	|	Enable_Choice
	|	Omit
	|	No_Label
	|	Discard
	|	Help
	|	Overlays
	|	Follows
	|	On_CR
	|	VAdjust
	|	Width
	|	Body_Color
	|	On_Color
	|	Label_Color
	;

On_Entry :	ON_ENTRY Block
		{ fprintf(fcode,
			  "\n/* On_Entry %d %s */\nvoid fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $2);
		  setopt(Node_On_Entry(UITOP), cases); }
	;

/* Either a block of code or the name of a suitable call */

Enable_Choice :	ENABLE_CHOICE Block
		{ fprintf(fcode,
			  "\n/* Enable_Choice %d %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $2);
		  setopt(Node_Enable_Choice(UITOP), cases); }
	|	ENABLE_CHOICE TEXT
		{ fprintf(ftree,
			  "\n/* Enable_Choice %d %s */\n#define fun%d %s\n",
		  UITOP, Node_Name(UITOP), ++cases, $2);
		  setopt(Node_Enable_Choice(UITOP), cases); }
	;

Omit:		OMIT Omit_Rest ;

Omit_Rest:	/* nothing */
		{ Node_Omit(UITOP) = 1; }
	|	Block
		{ fprintf(fcode,
			  "\n/* Omit %d %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Omit(UITOP), cases); }
	|	TEXT
		{ fprintf(ftree,
			  "\n/* Omit %d %s */\n#define fun%d %s\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Omit(UITOP), cases); }
	;

Event_Test :	EVENT_TEST Block
		{ fprintf(fcode,
			  "\n/* Event_Test %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $2);
		  setopt(Node_Event_Test(UITOP), cases); }
	;

Enable_Ok:	ENABLE_OK En_Ok_Rest ;

En_Ok_Rest:	/* nothing */
		{ Node_Enable_Ok(UITOP) = 1; }
	|	Block
		{ fprintf(fcode,
			  "\n/* Enable_Ok %d %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Enable_Ok(UITOP), cases); }
	|	TEXT
		{ fprintf(ftree,
			  "\n/* Enable_Ok %d %s */\n#define fun%d %s\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Enable_Ok(UITOP), cases); }
	;

Action :	ACTION Block
		{ fprintf(fcode,
			"\n/* Action %d %s */\nchar * fun%d (NODEID nodeid) {%s",
			UITOP, Node_Name(UITOP),
			++cases,
			$2);
		  fprintf(fcode,
			  "\nreturn (char *)0; }\n");
		  setopt(Node_Action(UITOP), cases); }
	|	ACTION_MSG Block
		{ fprintf(fcode,
			"\n/* actiOn_Msg %d %s */\nchar * fun%d (NODEID nodeid) {%s}\n",
			UITOP, Node_Name(UITOP),
			++cases,
			$2);
		  setopt(Node_Action(UITOP), cases); }
	;

On_Exit :	ON_EXIT Block
		{ fprintf(fcode,
			  "\n/* On_Exit %d %s */\nvoid fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $2);
		  setopt(Node_On_Exit(UITOP), cases); }
	;

Summary :	SUMMARY Block
		{ fprintf(fcode,
			  "\n/* Summary %d %s */\nchar * fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $2);
		  setopt(Node_Summary(UITOP), cases); }
	;

Auto_Select :	AUTO_SELECT Block
		{ fprintf(fcode,
			  "\n/* Auto_Select %s */\nchar * fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $2);
		  Node_Auto_Select(UITOP) = cases; }
	;

Highlight :	HIGHLIGHT Block
		{ fprintf(fcode,
			  "\n/* Highlight %s */\nchar * fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $2);
		  Node_Highlight(UITOP) = cases; }
	;

Conf_Msg :	CONFIRM_MSG Block
		{ fprintf(fcode,
			  "\n/* Conf_Msg %d %s */\nchar * fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $2);
		  Node_Conf_Msg(UITOP) = cases; }
	;

Help :		HELP TEXT
		{ Node_Help(UITOP) = $2; }
	;

/* These can be declared with constant names or code yielding names.
   The constant is validated at translation time,
   but code result not until run time. */

Overlays :	OVERLAYS { want_token = SIBLING; }
			Over_Rest { want_token = TEXT; }
	;

Over_Rest:	SIBLING
		{ fprintf(fcode,
			  "\n/* Overlays_Sib %s */\nchar * fun%d (NODEID nodeid) { return \"%s\"; }\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Overlays(UITOP), cases); }
	|	Block
		{ fprintf(fcode,
			  "\n/* Overlays_Fun %s */\nchar * fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Overlays(UITOP), cases); }
	;

Follows :	FOLLOWS { want_token = SIBLING; }
			Follow_Rest { want_token = TEXT; }
	;

Follow_Rest:	SIBLING
		{ fprintf(fcode,
			  "\n/* Follows_Sib %s */\nchar * fun%d (NODEID nodeid) { return \"%s\"; }\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Follows(UITOP), cases); }
	|	Block
		{ fprintf(fcode,
			  "\n/* Follows_Fun %s */\nchar * fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Follows(UITOP), cases); }
	;

On_CR :		ON_CR On_CR_Rest ;

On_CR_Rest :	/* nothing */
		{ Node_On_Cr(UITOP) = "+"; }
	|	TEXT
		{ Node_On_Cr(UITOP) = $1; }
	;

/* These can be declared either as a simple flag or test. */

Remain :	REMAIN Rem_Rest ;

Rem_Rest:	/* nothing */
		{ Node_Remain(UITOP) = 1; }
	|	Block
		{ fprintf(fcode,
			  "\n/* Remain %d %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Remain(UITOP), cases); }
	|	TEXT
		{ fprintf(ftree,
			  "\n/* Remain %d %s */\n#define fun%d %s\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Remain(UITOP), cases); }
	;

Confirm :	CONFIRM Conf_Rest ;

Conf_Rest:	/* nothing */
		{ Node_Confirm(UITOP) = 1; }
	|	Block
		{ fprintf(fcode,
			  "\n/* Confirm %d %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Confirm(UITOP), cases); }
	|	TEXT
		{ fprintf(ftree,
			  "\n/* Confirm %d %s */\n#define fun%d %s\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Confirm(UITOP), cases); }
	;

No_Label :	NO_LABEL No_Label_Rest ;

No_Label_Rest:	/* nothing */
		{ Node_No_Label(UITOP) = 1; }
	|	Block
		{ fprintf(fcode,
			  "\n/* noLabel %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_No_Label(UITOP), cases); }
	;

Width :		WIDTH Width_Rest ;


Width_Rest:	INTEGER
		{ fprintf(fcode,
			  "\n/* Width_Nr %d %s */\nlong fun%d (NODEID nodeid) { return %d; }\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Term_Width(UITOP), cases); }
	|	Block
		{ fprintf(fcode,
			  "\n/* Width_Fun %d %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Term_Width(UITOP), cases); }
	;

Fill_Color :	FILL_COLOR Block
		{ fprintf(fcode,
			  "\n/* Fill_Color %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $2);
		  Node_Fill_Color(UITOP) = cases; }
	;

Body_Color :	BODY_COLOR Block
		{ fprintf(fcode,
			  "\n/* Body_Color %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $2);
		  Node_Body_Color(UITOP) = cases; }
	;

On_Color :	ON_COLOR Block
		{ fprintf(fcode,
			  "\n/* On_Color %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $2);
		  Node_On_Color(UITOP) = cases; }
	;

Label_Color :	LABEL_COLOR Block
		{ fprintf(fcode,
			  "\n/* Label_Color %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $2);
		  Node_Label_Color(UITOP) = cases; }
	;

Discard :	DISCARD Disc_Rest ;

Disc_Rest:	/* nothing */
		{ Node_Discard(UITOP) = 1; }
	|	Block
		{ fprintf(fcode,
			  "\n/* Discard %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $1);
		  Node_Discard(UITOP) = cases; }
	|	TEXT
		{ fprintf(ftree,
			  "\n/* Discard %s */\n#define fun%d %s\n",
		  Node_Name(UITOP), ++cases, $1);
		  setopt(Node_Discard(UITOP), cases); }
	;

Auto_Ok:	AUTO_OK aok_Rest ;

aok_Rest:	/* nothing */
		{ Node_Auto_Ok(UITOP) = 1; }
	|	Block
		{ fprintf(fcode,
			  "\n/* Auto_Ok %d %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  UITOP, Node_Name(UITOP), ++cases, $1);
		  Node_Auto_Ok(UITOP) = cases; }
	;

Read_Only:	READ_ONLY Rdonly_Rest ;

Rdonly_Rest:	/* nothing */
		{ Node_Read_Only(UITOP) = 1; }
	|	Block
		{ fprintf(fcode,
			  "\n/* Read_Only %s */\nlong fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $1);
		  Node_Read_Only(UITOP) = cases; }
	;

Str_NEcho:	NO_ECHO NEcho_Rest ;

NEcho_Rest:	/* nothing */
		{ Node_Str_No_Echo(UITOP) = 1; }
	|	Block
		{ fprintf(fcode,
			  "\n/* Str_NEcho %s */\nlong fun%d (NODEID nodeid) {%s}",
		  Node_Name(UITOP), ++cases, $1);
		  Node_Str_No_Echo(UITOP) = cases; }
	;

/* Application routines to handle mouse actions.
   Globals MOUSE_X, MOUSE_Y, MOUSE_Y are available. */

Mouse_Pick :   MOUSE_PICK Block
		{ fprintf(fcode,
			  "\n/* Mouse_Pick %s */\nvoid fun%d (NODEID nodeid) {%s}\n",
		  Node_Name(UITOP), ++cases, $2);
		  Node_Pick(UITOP) = cases; }
	;

/* Note the spec source line number at start of a code block,
   for easier source file debugging.

   Compiler errors report these instead of actual C code lines,
   possibly offset down from the most recent one noted.

   Parser errors also report these line numbers at uitoc-time.

   These numbers in spec source are after processing by m4 utility,
   which "inflates" them by adding lines for macro expansion,
   so not quite what you see in the file but close. */

Block:		{ fprintf(fcode, "\n# line %d\n", yylineno); }
		BLOCK
		{ $$ = $2; }

%%

void yyerror(char *msg)
{
    extern int yylineno;
    extern char yytext[];

    printf("error near line %d / %s ", yylineno, yytext);

    if (msg)
      printf(" %s", msg);

    printf("\n");
    return;
}

